/*******************************************************************************
* Functions used to support the Taurus navigation menu. Some code based on:
* AnyLink Drop Down Menu- ? Dynamic Drive (www.dynamicdrive.com)
* This notice MUST stay intact for legal use
* Visit http://www.dynamicdrive.com/ for full source code.
*
* Note that this requires that the page contains the following variables:
* - allowRefresh , which determines whether the navigation takes effect. This is
*   added by header.js
* - a div with an id = dropmenudiv, used to display the menu. This is added by
*   the menuPanel.
* - If the browser is IE, it should also contain an iframe with an id =
*   dropmenuIFrame. This covers combo boxes which otherwise show through. The
*   iframe must NOT be included if the browser is Konqueror, as it doesn't
*   display them correctly. This is added by the menuPanel.
*******************************************************************************/
var menuwidth='100px' //default menu width
var disappeardelay=250  //menu disappear speed onMouseout (in milliseconds)
var hidemenu_onclick="yes" //hide menu when user clicks within menu?
var ie4=document.all
var ns6=document.getElementById&&!document.all
var pendingMenuHide = false;
var dropmenuobj;
var dropmenuframe;

function getposOffset(what, offsettype)
{
  var totaloffset=(offsettype=="left")? what.offsetLeft : what.offsetTop;
  var parentEl=what.offsetParent;
  
  while (parentEl!=null)
  {
    totaloffset=(offsettype=="left")? totaloffset+parentEl.offsetLeft 
                                    : totaloffset+parentEl.offsetTop;
    parentEl=parentEl.offsetParent;
  }
  return totaloffset;
}

//Replaces showhidemenu -DH
function showmenu(menuwidth)
{
  if (ie4||ns6)
    dropmenuobj.style.left=dropmenuobj.style.top=-500
      if (typeof dropmenuframe!="undefined")
      {
        dropmenuframe.style.left=dropmenuframe.style.top=-500
      }
  if (menuwidth!="")
  {
    dropmenuobj.widthobj=dropmenuobj.style
    dropmenuobj.widthobj.width=menuwidth
    if (typeof dropmenuframe!="undefined")
    {
      dropmenuframe.style.width=menuwidth;
    }
  }
  dropmenuobj.style.visibility="visible"
  if (typeof dropmenuframe!="undefined")
  {
    dropmenuframe.style.visibility="visible";
  }
}

function iecompattest()
{
  return (document.compatMode &&
          document.compatMode!="BackCompat")? document.documentElement 
                                            : document.body
}

function clearbrowseredge(obj, whichedge)
{
  var edgeoffset=0
  
  if (whichedge=="rightedge")
  {
    var windowedge=ie4 && !window.opera? iecompattest().scrollLeft+iecompattest().clientWidth-15 
                                       : window.pageXOffset+window.innerWidth-15

    dropmenuobj.contentmeasure=dropmenuobj.offsetWidth
    if (windowedge-dropmenuobj.x < dropmenuobj.contentmeasure)
      edgeoffset=dropmenuobj.contentmeasure-obj.offsetWidth
  }
  else
  {
    var topedge=ie4 && !window.opera? iecompattest().scrollTop : window.pageYOffset
    var windowedge=ie4 && !window.opera? iecompattest().scrollTop+iecompattest().clientHeight-15 : 

    window.pageYOffset+window.innerHeight-18
    dropmenuobj.contentmeasure=dropmenuobj.offsetHeight
    if (windowedge-dropmenuobj.y < dropmenuobj.contentmeasure)
    { //move up?
      edgeoffset=dropmenuobj.contentmeasure+obj.offsetHeight
      if ((dropmenuobj.y-topedge)<dropmenuobj.contentmeasure) //up no good either?
        edgeoffset=dropmenuobj.y+obj.offsetHeight-topedge
    }
  }
  return edgeoffset
}

function populatemenu(what)
{
  if (ie4||ns6)
    dropmenuobj.innerHTML=what.join("")
}

function dropdownmenu(obj, e, menucontents, menuwidth)
{
  if (window.event)
    event.cancelBubble=true
  else if (e.stopPropagation)
    e.stopPropagation()
  clearhidemenu()
  dropmenuobj=document.getElementById? document.getElementById("dropmenudiv") 
                                     : dropmenudiv
  if (document.getElementById("dropmenuIFrame") != null)
  {
    dropmenuframe=document.getElementById? document.getElementById("dropmenuIFrame") 
                                         : dropmenuIFrame;
  }
  populatemenu(menucontents)

  if (ie4||ns6)
  {
    var leftOffset = clearbrowseredge(obj, "rightedge");
    var topOffset = clearbrowseredge(obj, "bottomedge");
    
    showmenu(menuwidth)
    dropmenuobj.x=getposOffset(obj, "left")
    dropmenuobj.y=getposOffset(obj, "top")
    dropmenuobj.style.left = dropmenuobj.x - leftOffset + "px"
    dropmenuobj.style.top = dropmenuobj.y - topOffset + obj.offsetHeight + "px"
    if (typeof dropmenuframe!="undefined")
    {
      dropmenuframe.x=dropmenuobj.x;
      dropmenuframe.y=dropmenuobj.y;
      dropmenuframe.style.left = dropmenuobj.style.left;
      dropmenuframe.style.top = dropmenuobj.style.top;
      dropmenuframe.style.height = dropmenuobj.clientHeight + 2;
    }
  }

  return clickreturnvalue()
}

function clickreturnvalue()
{
  if (ie4||ns6)
    return false
  else
    return true
}

function contains_ns6(a, b)
{
  while (b.parentNode)
    if ((b = b.parentNode) == a)
      return true;
  return false;
}

function dynamichide(e)
{
  if (ie4&&!dropmenuobj.contains(e.toElement))
    delayhidemenu()
  else if (ns6&&e.currentTarget!= e.relatedTarget &&
           !contains_ns6(e.currentTarget, e.relatedTarget))
  delayhidemenu()
}

function hidemenu(e)
{
  if (pendingMenuHide && typeof dropmenuobj!="undefined")
  {
    if (ie4||ns6)
    {
      document.getElementById("menuItem_0").focus();
      dropmenuobj.style.visibility="hidden"
      dropmenuobj.innerHTML=""; //Prevent Konqueror tabbing through the fields -DH
      if (typeof dropmenuframe!="undefined")
      {
        dropmenuframe.style.visibility="hidden";
      }
    }
    pendingMenuHide = false
  }
}

function delayhidemenu()
{
  if (ie4||ns6)
  {
    delayhide=setTimeout("hidemenu()",disappeardelay)
    pendingMenuHide = true
  }
}

function clearhidemenu()
{
  if (typeof delayhide!="undefined")
  {
    clearTimeout(delayhide)
    pendingMenuHide = false
  }
}

if (hidemenu_onclick=="yes")
  document.onclick=hidemenu
  
//*** Nanometrics code (added to support keys) *********************************
var menuDisplaying = false;
var movingInMenu = false;

function handleMenuHeaderKeydown(thisEvent, obj)
{
  var keyCode = getKeyCode(thisEvent);
  
  if (keyCode == 9 || keyCode == 16) //tab or shift
  {
    return;
  }

  if (menuDisplaying)
  {
    if (getKeyCode(thisEvent) == 13 || getKeyCode(thisEvent) == 0)
    { //Enter key or Konqueror center button 
      closeMenu();
    }
    else
    {
      handleMenuItemKeydown(thisEvent, obj.id);
    }
    return movingInMenu;
  }
  else
  {
    openMenu(thisEvent, obj);
    return false; //Stop the navigation
  }
}

function checkMenuMovementDestination()
{
  if (movingInMenu)
  {
    movingInMenu = false;
  }
  else if (menuDisplaying)
  {
    closeMenu();
  }
}

function openMenu(thisEvent, obj)
{
  menuDisplaying = true;
  return dropdownmenu(obj, thisEvent, navigationMenu, '135px');
}

function closeMenu()
{
  menuDisplaying = false;
  delayhidemenu();
 
}

function handleMenuItemKeydown(thisEvent, itemId)
{
  var theKey = getKeyCode(thisEvent);
  if (theKey != -1)
  {
 		var row = parseInt(itemId.substring(9), 10);
 		
 		switch(theKey)
 		{
 		  case 38:
 		  case 22:
 		    // up
 		    if (row > 0)
 		    {
 		      row --;
 		    }
 		    else
 		    {
 		      row = navigationMenu.length;
 		    }
 		    movingInMenu = true;
 		    break;
 		  case 40:
 		  case 23:
 		    // down
 		    if (row < navigationMenu.length)
 		    {
 		      row ++;
 		    }
 		    else
 		    {
 		      row = 0;
 		    }
 		    movingInMenu = true;
 		    break;
 		  default:
 		  	return;
 		}
 		var newItemId = "menuItem_" + row;
 		if (newItemId != itemId)
 		{
 		  var element = document.getElementById(newItemId);
 		  if (typeof element != "undefined")
 		  {
 		    element.focus();
 		  }
 		}
  }
}

function getKeyCode(keydownEvent)
{
  var theEvent = (keydownEvent) ? keydownEvent : ((window.event) ? event : null);
  if (theEvent)
  {
    var theKey = theEvent.keyCode;
    if (typeof theEvent.virtKeyVal != "undefined")
    {
      theKey = theEvent.virtKeyVal;
    }
    return theKey;
  }
  return -1;
}

function gotoPage(pageName)
{
  closeMenu();
  if (pageName != null)
  {
  	if (stopRefresh())
  	{
      window.location = pageName;
    }
  }
}
