/*******************************************************************************
* Variables and functions used by pages in this application. Other JavaScript
* code in the pages may require these to be present.
*******************************************************************************/
var passed = location.search.substring(1);
var allowRefresh = true; //Don't allow refreshes when the page is <re>loading - Konqueror crashes 

/*******************************************************************************
 * Support the virtual keyboard "keys" page which may have other uses.
 * getParam can get URL parameters from the URL of the current page
 */
function getParam(string, parm) {
	// returns value of parm from string
	var startPos = string.indexOf(parm + "=");
	if (startPos > -1) {
    startPos = startPos + parm.length + 1;
    var endPos = string.indexOf("&",startPos);
    if (endPos == -1)
	    endPos = string.length;
    return unescape(string.substring(startPos,endPos));
	}
	return '';
}

/*******************************************************************************
 * Called by form submissions and hyperlink clicks to turn off subsequent
 * refreshes. It also returns false if refreshes have already been turned off,
 * so its return value should be used to block these sources of page changes.
 */
function stopRefresh() {
	if (!allowRefresh) {
		return false;
	}
	allowRefresh = false;
	return true;
}

/*******************************************************************************
 * Used to submit forms programmatically, since calling submit() doesn't fire 
 * the form's onsubmit event.
 */
function safeFormSubmit(form)
{
  if (stopRefresh() && typeof form != "undefined")
  {
    form.submit();
  }
}
